SystemOrganization addCategory: #'Xenon-Tests'!

Object subclass: #XeEmptyFunctionWhenItHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyFunctionWhenItHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeEmptyFunctionWhenReturnTypeIsDefaultScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyFunctionWhenReturnTypeIsDefaultScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeEmptyFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeEmptyFunctionWhenReturnTypeIsUnknownScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyFunctionWhenReturnTypeIsUnknownScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #unknown>
! !

TestCase subclass: #XeTranslateFunctionTest
	instanceVariableNames: 'xenon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest methodsFor: 'running' stamp: 'BernardoContreras 3/15/2012 23:04'!
setUp
	xenon := Xenon new! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 3/25/2012 00:23'!
testTranslateEmptyFunctionWhenItHasManyReturnTypes
	self should: [xenon translate: XeEmptyFunctionWhenItHasManyReturnTypeScenario] raise: XeTooManyReturnTypesError
! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 3/25/2012 00:42'!
testTranslateEmptyFunctionWhenReturnTypeIsDefault
	| actual expected |
	actual := xenon translate: XeEmptyFunctionWhenReturnTypeIsDefaultScenario.
	expected := 'sqInt foo(){
}'.
	self assert: actual equals: expected! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 3/25/2012 00:25'!
testTranslateEmptyFunctionWhenReturnTypeIsInteger
	| actual expected |
	actual := xenon translate: XeEmptyFunctionWhenReturnTypeIsIntegerScenario.
	expected := 'int foo(){
}'.
	self assert: actual equals: expected! !

!XeTranslateFunctionTest methodsFor: 'tests' stamp: 'BernardoContreras 3/25/2012 00:24'!
testTranslateEmptyFunctionWhenReturnTypeIsUnknown
	
	self should: [xenon translate: XeEmptyFunctionWhenReturnTypeIsUnknownScenario] raise: XeTypeNotFoundError
! !
